%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                               %
% Schreibe ein zweistelliges Prädikat gerade/2, das gelingt,                    %
% wenn das erste Argument eine Liste von Zahlen ist und das zweite              %
% Argument die Anzahl der geraden Zahlen ist, die in der Liste vorkommen.       %
%                                                                               %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%% Lösung 
% gerade/2

gerade(L,GZ):-                                  % Als 1. Argument wird eine Liste eingelesen, das 2. Argument
                                                % sind alle geraden Zahlen dieser Liste,
gerade_acc([],GZ,GZ).                           % solange bis die Liste leer ist.

% Wenn H gerade ist: 
gerade_acc([H|T],Acc,GZ):-                      % Wenn die erste Zahl der Liste als Head gespeichert wird und
   1 is H mod 2,                                % H durch 2 dividiert Modulo 1 ergibt,
   gerade_acc(T,Acc,GZ).                        % wird der Aufruf rekursiv gestartet.

% Wenn H ungerade ist: 
gerade_acc([H|T],Acc,GZ):-                      % Wenn die erste Zahl der Liste als Head gespeichert wird und
   0 is H mod 2,                                % H durch 2 dividiert Modula 0 ergibt,
   NewAcc is Acc + 1,                           % wird der Akkumulator um 1 addiert und
   gerade_acc(T,NewAcc,GZ).                     % der Aufruf rekursiv gestartet.
