%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                               %
% Schreibe ein Prädikat sameLength/2 das zwei Listen            % 
% akzeptiert, wenn sie dieselbe Länge haben.                    %
%                                                               %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%% Lösung
% traces für len1([a,b,c],X) und len2([a,b,c],X).

% ohne Akkumulator
len1_schlecht([],0).                    % Erfolgt keine Eingabe, wird die Anfrage beendet, Listenlänge ist dann 0.
len1_schlecht([_|T],N):-                % Wenn im Tail noch Einträge sind, 
        N is X+1,                       % wird die Längenangabe durch X + 1 ersetzt 
        len1_schlecht(T,X).             % und es erfolgt der rekursive Aufruf.

% mit Akkumulator
len2_schlecht(List,Int):-               % Der Aufruf ist erfolgreich, wenn
    accLen_schlecht(List,0,Int).        % eine Liste eingelesen wird, die Listenlänge wird auf 0 gesetzt.

accLen_schlecht([],Acc,Acc).            % Erfolgt keine weitere Eingabe, ist die Länge der Liste gleich
                                        % der Länge des Akkumulators.

accLen_schlecht([_|T],Acc,L):-          % Die Elemente von L werden einzeln eingelesen und
    accLen_schlecht(T,NewAcc,L),        % der Counter wird im rekursiven Aufruf
    NewAcc is Acc+1.                    % von Acc auf NewAcc gesetzt indem 1 addiert wird.


% sameLength schreiben, zunächst mithilfe von len2/2
% Längenbestimmung mit Akkumulator
% mit Akkumulator

len2(List,Length):-                     % Die Liste wird eingelesen und 
  accLen(List,0,Length).                % der Längencount auf 0 gesetzt.

accLen([],Acc,Acc).                     % Es erfolgt keine weitere Eingabe, die Liste ist leer.

accLen([_|T],Acc,L):-                   % Die Elemente von L werden einzeln eingelesen und
  NewAcc is Acc+1,                      % der Counter um 1 erhöht und als NewAcc gespeichert und
  accLen(T,NewAcc,L).                   % es erfolgt der rekursive Aufruf.


% sameLength1/2
% sameLength1(L1,L2) gelingt, wenn die beiden Listen dieselbe Länge haben

sameLength1(L1,L2):-                    % Die Listen L1 und L2 haben die gleiche Länge, wenn
  len2(L1,Length),                      % die Länge von L1 und
  len2(L2,Length).                      % die Länge von L2 gleich sind.
  

% sameLength schreiben ohne Rückgriff auf len2.

% sameLength/2
% sameLength(L1,L2) gelingt, wenn die beiden Listen dieselbe Länge haben

sameLength([],[]).                      % Erfolgt keine weitere Eingabe, wird der Aufruf beendet.
sameLength([_|T1],[_|T2]):-             % Beide Listen haben die gleiche Länge, wenn
   sameLength(T1,T2).                   % T1 und T2 gleich viele Elemente haben, die rekursiv abgearbeit werden.
